//###################################################################################
// ~ International Laser Display Association ~
// ~     ILDA File Format Driver in C++      ~
// ~             Built for EZFB              ~
//
// by James Lehman
// Extra Stimulus Inc.
// james@akrobiz.com
//
// began: October 2003
//
//###################################################################################
#ifndef __EZ_COLOR_DEFINITIONS__
#define __EZ_COLOR_DEFINITIONS__

//###################################################################################
class ez_color
{
public:
    ez_color( const u_char& _r = 0,
              const u_char& _g = 0,
              const u_char& _b = 0
            )
            : r(_r), g(_g), b(_b)                      {};
    //-------------------------------------------------------------------------------
    ez_color(const ez_color& c)
            : r(c.r), g(c.g), b(c.b)                   {};
    //-------------------------------------------------------------------------------
    inline ez_color& operator = (const ez_color& c)
                            {
                                r = c.r;
                                g = c.g;
                                b = c.b;
                                return *this;
                            };
    //-------------------------------------------------------------------------------
    inline ez_color& operator = (const u_char& c)
                            {
                                r = c;
                                g = c;
                                b = c;
                                return *this;
                            };
    //-------------------------------------------------------------------------------
    inline bool operator == (const ez_color& c) const
                        {  
                            if(    (r != c.r)
                                || (g != c.g)
                                || (b != c.b)
                              )
                                return false;
                            return true;
                        };
    //-------------------------------------------------------------------------------
    inline bool operator != (const ez_color& c) const
                        {   
                            if(    (r == c.r)
                                && (g == c.g)
                                && (b == c.b)
                              )
                                return false;
                            return false;
                        };
    //-------------------------------------------------------------------------------
    inline bool operator >  (const ez_color& c) const
                        {                        
                            return(   (  r << 16 |   g << 8 |   b)
                                    > (c.r << 16 | c.g << 8 | c.b)
                                  );
                        };
    //-------------------------------------------------------------------------------
    inline bool operator <  (const ez_color& c) const
                        {                        
                            return(   (  r << 16 |   g << 8 |   b)
                                    < (c.r << 16 | c.g << 8 | c.b)
                                  );
                        };
    //-------------------------------------------------------------------------------
    int  from_ifstream (ifstream& in)
                        {
                            r = (u_char)in.get();
                            g = (u_char)in.get();
                            b = (u_char)in.get();
                            return in.bad();
                        };
    //-------------------------------------------------------------------------------
    void  to_ofstream  (ofstream& out) const
                        {
                            out.put((char)r);
                            out.put((char)g);
                            out.put((char)b);
                            return;
                        };
    //-------------------------------------------------------------------------------
    u_char r, g, b;
};


//###################################################################################
#endif

//###################################################################################
/////////////////////////////////////////////////////////////////////////////////////
//###################################################################################



