//############################################################################
// ~ International Laser Display Association ~
// ~     ILDA file format driver in C++      ~
// ~             built for EZFB              ~
//
// by James Lehman
// Extra Stimulus Inc.
// james@akrobiz.com
//
// began: October 2003
//
//############################################################################
#include "ez_ilda_common.hpp"

//############################################################################
const double pi                = (4 * atan(1.0))  ;
const double two_pi            = (pi * 2.0)       ;
const double quarter_pi        = (pi / 4.0)       ;
const double half_pi           = (pi / 2.0)       ;
const double three_quarters_pi = (3 * quarter_pi) ;
const double one_degree        = (pi / 180.0)     ;
const double one_radian        = (180.0 / pi)     ;

//############################################################################
float ez_random_01() // returns a float between 0 & 1.
{
    return ((float)(rand()) / (float)RAND_MAX);
}

//############################################################################
float ez_random_neg_to_pos_1() // returns a float between -1 & 1.
{
    return ez_random_01() - ez_random_01();
}

//############################################################################
bool get_dxf_pair(ifstream& in, int& group_code, string& entity_string)
{
    char line[1025];
    in >> group_code;
    if(group_code != -1)
    {
        while(isspace(in.peek()))
            in.get(); // eat the '\r''\n'

        in.getline(line, 1024); // dxf limit is 256
        entity_string = line;

        int i = entity_string.size() - 1;
        while(!isgraph(entity_string[i]))
            i--;

        entity_string = entity_string.substr(0, i + 1);
    }
    return (group_code != 0 && !in.eof());
}

//############################################################################
//////////////////////////////////////////////////////////////////////////////
//############################################################################



